/*
 * Created on 10-sep-2007
 */
package be.ASPL.presentationlayer;

import be.SIRAPRISE.util.Localizer;

/**
 * @author Erwin Smout
 */
public class ASPLApplicationException extends ASPLException {

	/**
	 * 
	 */
	private static final long serialVersionUID = -5310263254754854641L;

	/**
	 * Creates the exception object, using the generic application error message text, which includes the name of the root cause's exception type, and its message text.
	 * 
	 * @param e
	 *            The exception that caused this exception to be thrown
	 */
	public ASPLApplicationException (Exception e) {
		super(I18N.getInstance(), "ASPLApplicationException.Text", new String[] { e.getMessage(), e.getClass().getName() }); //$NON-NLS-1$
	}

	/**
	 * Creates the exception object, using the generic application error message text, which includes the name of the root cause's exception type, and its message text.
	 * 
	 * @param localizer
	 *            The locale in which to set the message text
	 * @param localeTextTemplateID
	 *            The key that will allow the localizer to obtain the correct mesage text template
	 * @param params
	 *            The parameters to be used by the localizer when filling in the message text template to obtain an actual message
	 */
	public ASPLApplicationException (Localizer localizer, String localeTextTemplateID, String... params) {
		super(localizer, localeTextTemplateID, params);
	}
}