/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class CheckBoxRenderer extends Renderer {

	/**
	 * 
	 */
	private static final String DEFAULTCSSCLASS = "inputcheckbox"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new CheckBoxRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the CheckBoxRenderer
	 * 
	 */
	private CheckBoxRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		return "<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"checkbox\" name=\"" + presentationField.getName() + "\"" + (presentationField.isInputEnabled() ? "" : "disabled=\"disabled\"") + getHTMLTabIndexSpec(presentationField) + ">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationFieldValue instanceof LogicalValue) {
			StringBuilder fieldHtml = new StringBuilder(80).append("<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"checkbox\" name=\"" + presentationField.getName() + "\""); //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$
			LogicalValue logicalValue = (LogicalValue) presentationFieldValue;
			if (logicalValue.getValue()) {
				fieldHtml.append(" CHECKED "); //$NON-NLS-1$
			}
			if (!presentationField.isInputEnabled()) {
				fieldHtml.append(" disabled=\"disabled\" "); //$NON-NLS-1$
			}
			fieldHtml.append(getHTMLTabIndexSpec(presentationField)).append(">"); //$NON-NLS-1$
			return fieldHtml.toString();
		} else {
			throw new IllegalArgumentException(presentationFieldValue.getClass().getName());
		}
	}
}
