package be.ASPL.presentationlayer;

import java.util.Locale;

import be.SIRAPRISE.util.MyMessageFormat;

/**
 * @author Erwin
 */
public class List extends PresentationType<ListValue> {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.PresentationType#checkValidWaarValue(be.ASPL.presentationlayer.WaarValue, be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public ListValue checkValidWaarValue (PresentationValue value, UserData userData) throws InvalidAttributeValueException {
		if (!(value instanceof ListValue)) {
			Locale locale = userData.getLocale();
			throw new InvalidAttributeValueException(value.toASPLString(userData), this.getClass().getSimpleName(), MyMessageFormat.format(I18N.getString(locale, "DynamicColumnList.InvalidValueClass"), new String[] { getClass().getName(), value.getClass().getName() })); //$NON-NLS-1$
		}
		return (ListValue) value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.PresentationType#encode(byte[], be.ASPL.presentationlayer.UserData, java.util.Locale)
	 */
	@Override
	public ListValue encode (byte[] partBytes, UserData userData, Locale locale) throws InvalidAttributeValueException {
		throw new InvalidAttributeValueException("", this.getClass().getSimpleName(), I18N.getString(locale, "List.NoEncoding")); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.waar.AttributeType#validate(java.lang.String)
	 */
	public ListValue encode (String val, UserData userData, Locale locale) throws InvalidAttributeValueException {
		throw new InvalidAttributeValueException(val, this.getClass().getSimpleName(), I18N.getString(locale, "List.NoEncoding")); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.PresentationType#getDefaultPresentationRenderingStyle()
	 */
	@Override
	public Renderer getDefaultPresentationRenderingStyle ( ) {
		return ListRenderer.getInstance();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.PresentationAttributeType#decode(be.erwinsmout.ASPL.WaarValue)
	 */
	public String getNakedStringRepresentation (PresentationValue presentationValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale) {
		return Integer.toString(((ListValue) presentationValue).getRowList().size());
		//		String htmlFieldValue = ""; //$NON-NLS-1$
		// Iterator<?> ri = ((ListValue) presentationValue).getRowList().iterator();
		// HashMap<String, WaarValue> rowValueMap;
		// int rpb, rpe;
		//
		//		String fldHtml = ""; //$NON-NLS-1$
		// while (ri.hasNext()) {
		// // get the valuemap that holds the row
		// rowValueMap = (HashMap<String, WaarValue>) ri.next();
		// // reset the column iterator
		// StringBuffer rowHtml = new StringBuffer(presentationField.getRowTemplateText().toString());
		//			// Architecture.getInstance().trace(this.getClass().getName()+" - begin with row template "+rowHtml.toString()); //$NON-NLS-1$
		// do {
		//				rpb = rowHtml.toString().indexOf("[["); //$NON-NLS-1$
		// if (rpb >= 0) {
		// String rowFieldName = rowHtml.substring(rpb + 2);
		//					rpe = rowFieldName.indexOf("]]"); //$NON-NLS-1$
		// rowFieldName = rowFieldName.substring(0, rpe);
		//					// Architecture.getInstance().trace(this.getClass().getName()+" - row field "+rowFieldName); //$NON-NLS-1$
		// try {
		// fldHtml = Architecture.getArchitectureFieldValue(rowFieldName, userFunction);
		// } catch (NotAnArchitectureFieldException e) {
		// PresentationField lpf;
		// try {
		// lpf = presentationField.getColumn(rowFieldName, locale);
		// if (lpf != null) {
		// PresentationType lpft = lpf.getType();
		// if (rowValueMap.keySet().contains(rowFieldName)) {
		// WaarValue colValue = rowValueMap.get(rowFieldName);
		// fldHtml = lpft.getNakedStringRepresentation(colValue, userFunction, lpf, locale);
		// } else {
		// fldHtml = lpft.getEmptyNakedStringRepresentation(lpf, locale);
		// }
		// } else {
		// // not found in listfieldmap, maybe in 'outer' presentation map ...
		// HashMap<String, WaarValue> presentationValues = userFunction.getPresentation().getPresentationValues();
		// HashMap<String, PresentationField> presentationFields = userFunction.getPresentation().getPresentationFields();
		// if (presentationFields.containsKey(rowFieldName)) {
		// lpf = presentationFields.get(rowFieldName);
		// PresentationType lpft = lpf.getType();
		// if (presentationValues.keySet().contains(rowFieldName)) {
		// WaarValue colValue = presentationValues.get(rowFieldName);
		// fldHtml = lpft.getNakedStringRepresentation(colValue, userFunction, lpf, locale);
		// } else {
		// fldHtml = lpft.getEmptyNakedStringRepresentation(lpf, locale);
		// }
		// } else {
		//									fldHtml = "##" + rowFieldName + "##"; //$NON-NLS-1$//$NON-NLS-2$
		// }
		// }
		// } catch (NoColumnsInNonListFieldsException e1) {
		//
		// }
		// }
		//					// Architecture.getInstance().trace(this.getClass().getName()+" - row field value "+fldHtml); //$NON-NLS-1$
		// rowHtml.delete(rpb, rpb + rpe + 4);
		// rowHtml.insert(rpb, fldHtml);
		//					// Architecture.getInstance().trace(this.getClass().getName()+" - new row html "+rowHtml); //$NON-NLS-1$
		// }
		// } while (rpb >= 0);
		// htmlFieldValue += rowHtml;
		// }
		// return htmlFieldValue;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.PresentationType#getPresentationRenderingStyle(java.lang.String)
	 */
	@Override
	public Renderer getPresentationRenderingStyle (String renderingStyleName) {
		return ListRenderer.getInstance();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.PresentationType#getWaarValue(boolean, java.util.Locale)
	 */
	@Override
	public PresentationValue getWaarValue (boolean b, Locale locale) {
		throw new UnsupportedOperationException();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.PresentationType#getWaarValue(int)
	 */
	@Override
	public PresentationValue getWaarValue (int v, Locale locale) {
		throw new UnsupportedOperationException();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.PresentationType#getWaarValue(long, java.util.Locale)
	 */
	@Override
	public PresentationValue getWaarValue (long v, Locale locale) {
		throw new UnsupportedOperationException();
	}
}
