/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class VariableColumnListRenderer extends Renderer {

	/**
	 * 
	 */
	private static Renderer instance = new VariableColumnListRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the VariableColumnListRenderer
	 * 
	 */
	private VariableColumnListRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		return ""; //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		DynamicColumnListValue dynamicColumnListValue = (DynamicColumnListValue) presentationFieldValue;
		LinkedList<String> columnList = dynamicColumnListValue.getColumnList();
		StringBuilder fieldHtml = new StringBuilder(30 * dynamicColumnListValue.getRowList().size() * columnList.size());

		fieldHtml.append("<tr>"); //$NON-NLS-1$
		for (String columnName : columnList) {
			fieldHtml.append("<th>").append(columnName).append("</th>"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		fieldHtml.append("</tr>"); //$NON-NLS-1$

		String currentRowClassName = "tr1"; //$NON-NLS-1$
		LinkedList<HashMap<String, PresentationValue>> rowList = dynamicColumnListValue.getRowList();
		// iterate over the all the entries in the list
		for (HashMap<String, PresentationValue> row : rowList) {
			StringBuffer rowHtml = new StringBuffer("<tr class=\"" + currentRowClassName + "\">"); //$NON-NLS-1$ //$NON-NLS-2$
			currentRowClassName = currentRowClassName.equalsIgnoreCase("tr1") ? "tr2" : "tr1"; //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
			// reset the column iterator
			for (String columnName : columnList) {
				PresentationValue entryColumnValue = row.get(columnName);
				if (entryColumnValue != null) {
					if (entryColumnValue instanceof StringValue) {
						rowHtml.append("<td>" + ((StringValue) entryColumnValue).getString() + "</td>"); //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						rowHtml.append("<td><table class=\"nested\"><tbody>" + getHTML(entryColumnValue, userFunction, presentationField, locale, presentationLocaleLabels) + "</tbody></table></td>"); //$NON-NLS-1$ //$NON-NLS-2$
					}
				} else {
					rowHtml.append("<td> </td>"); //$NON-NLS-1$
				}
			}
			rowHtml.append("</tr>"); //$NON-NLS-1$
			fieldHtml.append(rowHtml);
		}

		return fieldHtml.toString();
	}
}
