package be.ASPL.webclient;

import be.ASPL.presentationlayer.ASPLException;
import be.ASPL.presentationlayer.InitialPresentation;
import be.ASPL.presentationlayer.OnLinePresentationFunctionCharacteristics;

/**
 * ColoursOverview displays an overview of colours in an image tag
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = ColourOverviewPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = false, descriptionLocalizationKey = "")
public class ColourOverview extends ASPLWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#startFunction()
	 */
	public void doInitialLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {

		setPresentationValue("COLOURS", (String) null); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getPresentationFunctionDescription()
	 */
	public String getPresentationFunctionDescription () {
		return "View Colours"; //$NON-NLS-1$
	}
}
