package be.ASPL.webclient;

import java.util.*;

import be.ASPL.presentationlayer.*;

/**
 * @version 1.0
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = UsersOverviewPresentation.class)
public class UsersOverview extends UsersFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doInitialLogic()
	 */
	public void doInitialLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		ListValue lv = new ListValue("USERLIST"); //$NON-NLS-1$
		Set<String> userIDs = Architecture.getAsplUsers(getApplicationName()).keySet();
		synchronized (userIDs) {
			Iterator<String> i = userIDs.iterator();
			while (i.hasNext()) {
				HashMap<String, PresentationValue> m = new HashMap<String, PresentationValue>();
				m.put("USERID", new StringValue(i.next())); //$NON-NLS-1$
				lv.append(m);
			}
		}
		setPresentationValue("USERLIST", lv); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getPresentationFunctionDescription()
	 */
	public String getPresentationFunctionDescription () {
		return "View the WAAR user list"; //$NON-NLS-1$
	}
}
