package be.SIRAPRISE.birdwatcher;

import be.ASPL.presentationlayer.ASPLException;
import be.ASPL.presentationlayer.ASPLListFactory;
import be.ASPL.presentationlayer.InitialPresentation;
import be.ASPL.presentationlayer.OnLinePresentationFunctionCharacteristics;

/**
 * The function to produce an overview of defined attributes
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = ExistingSpeciesOverviewPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = false, descriptionLocalizationKey = "ExistingSpeciesOverview.Text")
public class ExistingSpeciesOverview extends BWSpeciesFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doInitialLogic()
	 */
	public void doInitialLogic ( ) {
		setDefaultLanguageFromUserContext();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		setPresentationValue(ExistingSpeciesOverviewPresentation.SPECIESLIST, ASPLListFactory.getASPLListValue(getPresentation().getPresentationField(ExistingSpeciesOverviewPresentation.SPECIESLIST), getMatchingSpecies(), getUserData(), getUserLocale()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}
}