/**
 * 
 */
package be.SIRAPRISE.birdwatcher;

import java.util.*;

import be.SIRAPRISE.util.Localizer;

/**
 * @author Erwin
 * 
 */
final class I18N implements Localizer {

	/**
	 * 
	 */
	private static final HashMap<String, ResourceBundle> resourceBundleMap = new HashMap<String, ResourceBundle>();

	/**
	 * 
	 */
	private static final I18N instance = new I18N();

	/**
	 * @param locale
	 * @param key
	 * @return
	 */
	static String getString (Locale locale, String key) {
		ResourceBundle resourceBundle;
		String language = locale.getLanguage();
		if (resourceBundleMap.containsKey(language)) {
			resourceBundle = resourceBundleMap.get(language);
		} else {
			resourceBundle = ResourceBundle.getBundle(I18N.class.getName(), new Locale(language));
			resourceBundleMap.put(language, resourceBundle);
		}

		try {
			return resourceBundle.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	/**
	 * Prevent instantiation
	 */
	private I18N ( ) {

	}

	/**
	 * @return
	 */
	static Localizer getInstance ( ) {
		return instance;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.util.Localizer#getString(java.lang.String, java.util.Locale)
	 */
	@Override
	public String getString (String key, Locale locale) {
		return getString(locale, key);
	}
}
